Public Class clsInvert
    '### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### 
    '###  This class is a demonstration for the image processing         ###
    '###  software "TB-WebCam_Net" at www.goldengel.ch                   ###
    '###  TB-WebCam can handle                                           ###
    '###  Any input like Screen, Camera, Website.                        ###
    '###  Any effect like motion detection, inverting, noise reduction.  ###
    '###  Any output like COMM Port device, Fullscreen, image web upload.###
    '### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### 



    'Implements the DigitalSignalProcessing interface DSP
    Implements TB_Interface.clsInterfaces.VideoDspInterface





    'Event for sending any command to the main program
    Public Event SendCommand(ByVal sender As Object, ByVal Cmd As String, ByRef Value As Object) Implements TB_Interface.clsInterfaces.GlobalInterface.SendCommand

    'Keyboard and mouse events for sharing
    Public Event KeyboardKeyDownEvent(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Implements TB_Interface.clsInterfaces.MouseKeyOutInterface.KeyboardKeyDownEvent
    Public Event KeyboardKeyPressEvent(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Implements TB_Interface.clsInterfaces.MouseKeyOutInterface.KeyboardKeyPressEvent
    Public Event KeyboardKeyUpEvent(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Implements TB_Interface.clsInterfaces.MouseKeyOutInterface.KeyboardKeyUpEvent
    Public Event MouseDownEvent(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Implements TB_Interface.clsInterfaces.MouseKeyOutInterface.MouseDownEvent
    Public Event MouseMoveEvent(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Implements TB_Interface.clsInterfaces.MouseKeyOutInterface.MouseMoveEvent
    Public Event MouseUpEvent(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Implements TB_Interface.clsInterfaces.MouseKeyOutInterface.MouseUpEvent

    'Give your class any clearly name. Only a-z and A-Z allowed
    Private m_ClassKeyName As String = "Invert"

    'Describe your class with some words
    Private m_ClassDescription As String = "Invert the image"

    'Some variables. Basically controlled by the main program
    Private m_LinkId As Integer
    Private m_ExitActive As Boolean
    Private m_StartActive As Boolean
    Private m_ImageSize As Size
    Private m_ClassOrdnerNumber As Integer
    Private disposedValue As Boolean = False        ' So ermitteln Sie berflssige Aufrufe

    'If the class is active and should be used, this flag get to be true
    Private m_ImageNeeded As Boolean

    'Some variabled for inverting the image
    Private ImageAttr As New Imaging.ImageAttributes()
    Private InvertModus As InvertEnum

    'For having all commands in touch, you can make a list
    'of commands which can be executed by the main program.
    Private m_CommandDictionary As New Dictionary(Of String, Object)

    'The dongle tells you what license the main program has
    Private m_Dongle As TB_Interface.clsInterfaces.DongleEnum


    ''' <summary>
    ''' How the image should be calculated
    ''' When using Quick, the black pixels
    ''' can not be inverted because of 
    ''' multiplying by zero.
    ''' </summary>
    ''' <remarks></remarks>
    Private Enum InvertEnum As Integer
        Quick = 0
        Quality = 1
    End Enum

    'Inverted quick
    Dim MatrixInvertedQuick As New Imaging.ColorMatrix(New Single()() _
                       {New Single() {-1, 0, 0, 0, 0}, _
                        New Single() {0, -1, 0, 0, 0}, _
                        New Single() {0, 0, -1, 0, 0}, _
                        New Single() {0, 0, 0, 1, 0}, _
                        New Single() {0, 0, 0, 0, 1}})

    'Inverted correct
    Dim MatrixInvertedCorrect As New Imaging.ColorMatrix(New Single()() _
                           {New Single() {-1.0F, 0, 0, 0, 0}, _
                            New Single() {0, -1.0F, 0, 0, 0}, _
                            New Single() {0, 0, -1.0F, 0, 0}, _
                            New Single() {0, 0, 0, 1, 0}, _
                            New Single() {1, 1, 1, 0, 1}})




    ''' <summary>
    ''' This function is for the future
    ''' </summary>
    ''' <param name="VariantData"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function AdditionalModulFunction(ByRef VariantData As Object) As Object Implements TB_Interface.clsInterfaces.GlobalInterface.AdditionalModulFunction
        Return 0
    End Function


    ''' <summary>
    ''' Any Bitmap symbol as Icon for the class
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property ClassIcon48x48() As System.Drawing.Bitmap Implements TB_Interface.clsInterfaces.GlobalInterface.ClassIcon48x48
        Get
            Return My.Resources.Dsp_Invert
        End Get
    End Property


    ''' <summary>
    ''' Returns the keyname of the class
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property ClassKeyName() As String Implements TB_Interface.clsInterfaces.GlobalInterface.ClassKeyName
        Get
            Return m_ClassKeyName
        End Get
        Set(ByVal value As String)
            m_ClassKeyName = value
        End Set
    End Property


    ''' <summary>
    ''' Reports if the main program is closing
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property ExitActive() As Boolean Implements TB_Interface.clsInterfaces.GlobalInterface.ExitActive
        Get
            Return m_ExitActive
        End Get
        Set(ByVal value As Boolean)
            m_ExitActive = value
        End Set
    End Property


    ''' <summary>
    ''' If this clas has any dialog form to show, 
    ''' this property can return true. It will then
    ''' be used for "Function ShowOptionsDialog"
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property HasOptionsDialog() As Boolean Implements TB_Interface.clsInterfaces.VideoDspInterface.HasOptionsDialog
        Get
            Return False
        End Get
    End Property


    ''' <summary>
    ''' Shows any option form
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function ShowOptionsDialog() As Boolean Implements TB_Interface.clsInterfaces.VideoDspInterface.ShowOptionsDialog
        Return False
    End Function


    ''' <summary>
    ''' Reports if the main program is starting up
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property StartActive() As Boolean Implements TB_Interface.clsInterfaces.GlobalInterface.StartActive
        Get
            Return m_StartActive
        End Get
        Set(ByVal value As Boolean)
            m_StartActive = value
        End Set
    End Property

    ''' <summary>
    ''' Reports if the main program needs the image
    ''' from this class. Otherwise this class can sleep.
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property ImageNeeded() As Boolean Implements TB_Interface.clsInterfaces.VideoDspInterface.ImageNeeded
        Get
            Return m_ImageNeeded
        End Get
        Set(ByVal value As Boolean)
            m_ImageNeeded = value
        End Set
    End Property


    ''' <summary>
    ''' Calculate the inverted image
    ''' </summary>
    ''' <param name="SrcBitmap"></param>
    ''' <param name="gr"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function CalcDsp(ByVal SrcBitmap As System.Drawing.Bitmap, ByRef gr As System.Drawing.Graphics) As Integer Implements TB_Interface.clsInterfaces.VideoDspInterface.CalcDsp
        If SrcBitmap Is Nothing Then Return 0
        If InvertModus = InvertEnum.Quick Then
            ImageAttr.SetColorMatrix(MatrixInvertedQuick)
            gr.DrawImage(SrcBitmap, New Rectangle(0, 0, SrcBitmap.Width, SrcBitmap.Height), 0, 0, SrcBitmap.Width, SrcBitmap.Height, GraphicsUnit.Pixel, ImageAttr)
        End If
        If InvertModus = InvertEnum.Quality Then
            ImageAttr.SetColorMatrix(MatrixInvertedCorrect)
            gr.DrawImage(SrcBitmap, New Rectangle(0, 0, SrcBitmap.Width, SrcBitmap.Height), 0, 0, SrcBitmap.Width, SrcBitmap.Height, GraphicsUnit.Pixel, ImageAttr)
        End If
        Return 0
    End Function


    ''' <summary>
    ''' Description of the class
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property ClassDescription() As String Implements TB_Interface.clsInterfaces.GlobalInterface.ClassDescription
        Get
            Return m_ClassDescription
        End Get
        Set(ByVal value As String)
            m_ClassDescription = value
        End Set
    End Property


    ''' <summary>
    ''' Returns a list of commands for this class.
    ''' The value in the dictionary will be come back
    ''' in the "Function ReceiveCommand"
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property CommandDictionary() As System.Collections.Generic.Dictionary(Of String, Object) Implements TB_Interface.clsInterfaces.GlobalInterface.CommandDictionary
        Get
            Return m_CommandDictionary
        End Get
    End Property


    ''' <summary>
    ''' The main programm can send any command from 
    ''' the local "CommandDictionary" variable to
    ''' give this class a command.
    ''' </summary>
    ''' <param name="Cmd"></param>
    ''' <param name="Value"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function ReceiveCommand(ByVal Cmd As String, ByVal Value As Object) As Integer Implements TB_Interface.clsInterfaces.GlobalInterface.ReceiveCommand
        Try
            Me.InvertModus = CType(Value, clsInvert.InvertEnum)
        Catch ex As Exception

        End Try
    End Function

    ''' <summary>
    ''' Creates a new instance of this class
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub New()
        m_CommandDictionary.Add("[1]Invert quick", clsInvert.InvertEnum.Quick)
        m_CommandDictionary.Add("[1]Invert quality", clsInvert.InvertEnum.Quality)
    End Sub


    ''' <summary>
    ''' Number for the main program
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property ClassOrdnerNumber() As Integer Implements TB_Interface.clsInterfaces.GlobalInterface.ClassOrdnerNumber
        Get
            Return m_ClassOrdnerNumber
        End Get
        Set(ByVal value As Integer)
            m_ClassOrdnerNumber = value
        End Set
    End Property

    ''' <summary>
    ''' Keyboard key down event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Public Sub KeyboardKeyDownExt(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Implements TB_Interface.clsInterfaces.MouseKeyInInterface.KeyboardKeyDownExt

    End Sub

    ''' <summary>
    ''' Keyboard key press event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Public Sub KeyboardKeyPressExt(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Implements TB_Interface.clsInterfaces.MouseKeyInInterface.KeyboardKeyPressExt

    End Sub

    ''' <summary>
    ''' Keyboard key up event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Public Sub KeyboardKeyUpExt(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Implements TB_Interface.clsInterfaces.MouseKeyInInterface.KeyboardKeyUpExt

    End Sub

    ''' <summary>
    ''' Mouse down event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Public Sub MouseDownExt(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Implements TB_Interface.clsInterfaces.MouseKeyInInterface.MouseDownExt

    End Sub

    ''' <summary>
    ''' Mouse move event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Public Sub MouseMoveExt(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Implements TB_Interface.clsInterfaces.MouseKeyInInterface.MouseMoveExt

    End Sub

    ''' <summary>
    ''' Mouse up event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Public Sub MouseUpExt(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Implements TB_Interface.clsInterfaces.MouseKeyInInterface.MouseUpExt

    End Sub


    ''' <summary>
    ''' Identifier for the main program
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property LinkId() As Integer Implements TB_Interface.clsInterfaces.GlobalInterface.LinkId
        Get
            Return m_LinkId
        End Get
        Set(ByVal value As Integer)
            m_LinkId = value
        End Set
    End Property


    ''' <summary>
    ''' Dispose the class
    ''' </summary>
    ''' <param name="disposing"></param>
    ''' <remarks></remarks>
    Protected Overridable Sub Dispose(ByVal disposing As Boolean)
        If Not Me.disposedValue Then
            If disposing Then
                ' TODO: Verwaltete Ressourcen freigeben, wenn sie explizit aufgerufen werden
            End If

            ' TODO: Gemeinsam genutzte nicht verwaltete Ressourcen freigeben
            Call Me.Finalize()

        End If
        Me.disposedValue = True
    End Sub

#Region " IDisposable Support "
    ' Dieser Code wird von Visual Basic hinzugefgt, um das Dispose-Muster richtig zu implementieren.
    Public Sub Dispose() Implements IDisposable.Dispose
        ' ndern Sie diesen Code nicht. Fgen Sie oben in Dispose(ByVal disposing As Boolean) Bereinigungscode ein.
        Dispose(True)
        GC.SuppressFinalize(Me)
    End Sub
#End Region

    ''' <summary>
    ''' State of the license of the main program
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Dongle() As TB_Interface.clsInterfaces.DongleEnum Implements TB_Interface.clsInterfaces.GlobalInterface.Dongle
        Get
            Return m_Dongle
        End Get
        Set(ByVal value As TB_Interface.clsInterfaces.DongleEnum)
            m_Dongle = value
        End Set
    End Property
End Class
